解决依赖关系
yum -y install pcre-devel
下载apr apr-util:http://apr.apache.org/download.cgi
编译安装apr:
./configure --prefix=/usr/local/apr make && make install
编译安装apr-util:
./configure --prefix=/usr/local/apr-util --with-apr=/usr/local/apr make && make install
编译apache2.4.2:
[root@martin httpd-2.4.20]# ./configure --prefix=/usr/local/apache2.4.2 \ --sysconfdir=/etc/httpd \ --enable-so \ --enable--ssl \ --enable-cgi \ --enable-rewrite \ --with-zlib \ --with-pcre \ --with-apr=/usr/local/apr \ --with-apr-util=/usr/local/apr-util \ --enable-modeles=most \ --enable-mpms-shared=all \ --with-mpm=event
参数详解:
--prefix:#安装路径 --sysconfdir:#指定配置文件路径 --enable-so:#DSO兼容,DSO=Dynamic Shared Object,动态共享对象,可实现模块动态生效 --enable-ssl:#支持SSL/TLS,可实现https访问 需已安装openssl-devel --enable-cgi:#支持CGI脚本(默认对非线程的MPM模式开启) --enable-rewrite:#启用Rewrite功能,URL重写 --enable-deflate:#支持压缩功能 --with-zlib:#使用指定的zlib库,不指定路径会自动寻找 --with-pcre:#使用指定的PCRE库,不指定路径会自动寻找 需已安装pcre-devel --with-apr:#指定apr安装路径 --with-apr-util:#指定apr-util安装路径 --enable-mpms-shared:#支持动态加载的MPM模块,可选参数:all --with-mpm:#设置默认启用的MPM模式,{prefork|worker|event} --enable-modules:#支持动态启用的模块,可选参数:all,most,few,reallyall #编译之前可使用./configure --help查看各项参数
[root@martin local]# make && make install [root@martin local]# cd /usr/local [root@martin local]# ln -sv apache2.4.2/ apache
导入环境变量:
[root@martin local]# vim /etc/profile.d/httpd.sh export PATH=/usr/local/apache/bin:$PATH [root@martin local]# . /etc/profile.d/httpd.sh
编译配置查看:
[root@marvin ~]# cat /usr/local/apache/build/config.nice
启动文件:
[root@martin httpd]# vim /etc/rc.d/init.d/httpd
#!/bin/bash # # httpd Startup script for the Apache HTTP Server # # chkconfig: - 85 15 # description: The Apache HTTP Server is an efficient and extensible \ # server implementing the current HTTP standards. # processname: httpd # config: /etc/httpd/conf/httpd.conf # config: /etc/sysconfig/httpd # pidfile: /var/run/httpd/httpd.pid # ### BEGIN INIT INFO # Provides: httpd # Required-Start: $local_fs $remote_fs $network $named # Required-Stop: $local_fs $remote_fs $network # Should-Start: distcache # Short-Description: start and stop Apache HTTP Server # Description: The Apache HTTP Server is an extensible server # implementing the current HTTP standards. ### END INIT INFO # Source function library. . /etc/rc.d/init.d/functions if [ -f /etc/sysconfig/httpd ]; then . /etc/sysconfig/httpd fi # Start httpd in the C locale by default. HTTPD_LANG=${HTTPD_LANG-"C"} # This will prevent initlog from swallowing up a pass-phrase prompt if # mod_ssl needs a pass-phrase from the user. INITLOG_ARGS="" # Set HTTPD=/usr/sbin/httpd.worker in /etc/sysconfig/httpd to use a server # with the thread-based "worker" MPM; BE WARNED that some modules may not # work correctly with a thread-based MPM; notably PHP will refuse to start. # Path to the apachectl script, server binary, and short-form for messages. apachectl=/usr/local/apache/bin/apachectl httpd=${HTTPD-/usr/local/apache/bin/httpd} prog=httpd pidfile=${PIDFILE-/usr/local/apache/logs/httpd.pid} lockfile=${LOCKFILE-/var/lock/subsys/httpd} RETVAL=0 STOP_TIMEOUT=${STOP_TIMEOUT-10} # The semantics of these two functions differ from the way apachectl does # things -- attempting to start while running is a failure, and shutdown # when not running is also a failure. So we just do it the way init scripts # are expected to behave here. start() { echo -n $"Starting $prog: " LANG=$HTTPD_LANG daemon --pidfile=${pidfile} $httpd $OPTIONS RETVAL=$? echo [ $RETVAL = 0 ] && touch ${lockfile} return $RETVAL } # When stopping httpd, a delay (of default 10 second) is required # before SIGKILLing the httpd parent; this gives enough time for the # httpd parent to SIGKILL any errant children. stop() { echo -n $"Stopping $prog: " killproc -p ${pidfile} -d ${STOP_TIMEOUT} $httpd RETVAL=$? echo [ $RETVAL = 0 ] && rm -f ${lockfile} ${pidfile} } reload() { echo -n $"Reloading $prog: " if ! LANG=$HTTPD_LANG $httpd $OPTIONS -t >&/dev/null; then RETVAL=6 echo $"not reloading due to configuration syntax error" failure $"not reloading $httpd due to configuration syntax error" else # Force LSB behaviour from killproc LSB=1 killproc -p ${pidfile} $httpd -HUP RETVAL=$? if [ $RETVAL -eq 7 ]; then failure $"httpd shutdown" fi fi echo } # See how we were called. case "$1" in start) start ;; stop) stop ;; status) status -p ${pidfile} $httpd RETVAL=$? ;; restart) stop start ;; condrestart|try-restart) if status -p ${pidfile} $httpd >&/dev/null; then stop start fi ;; force-reload|reload) reload ;; graceful|help|configtest|fullstatus) $apachectl $@ RETVAL=$? ;; *) echo $"Usage: $prog {start|stop|restart|condrestart|try-restart|force-reload|reload|status|fullstatus|graceful|help|configtest}" RETVAL=2 esac exit $RETVAL
开机启动:
chmod +x /etc/rc.d/init.d/httpd chkconfig --add httpd chkconfig httpd on
安装php5.6 fast-cgi模式:
依赖:
yum install freetype-devel libpng-devel gd-devel libcurl-devel libjpeg-turbo-devel libxslt-devel zlib-devel libxml2-devel libiconv-devel bzip2-devel libmcrypt-devel -y
php-configure-apache:
./configure --prefix=/usr/local/phpfpm \ --with-config-file-path=/etc \ --with-config-file-scan-dir=/etc/php.d \ --with-mysql=mysqlnd \ --with-pdo-mysql=mysqlnd \ --with-mysqli=mysqlnd \ --with-iconv-dir \ --with-freetype-dir \ --with-jpeg-dir \ --with-png-dir \ --with-zlib \ --with-libxml-dir \ --enable-xml \ --disable-rpath \ --enable-bcmath \ --enable-shmop \ --enable-sysvsem \ --enable-inline-optimization \ --with-curl \ --enable-mbregex \ --enable-fpm \ --enable-mbstring \ --with-mcrypt \ --with-gd \ --enable-gd-native-ttf \ --with-openssl \ --with-mhash \ --enable-pcntl \ --enable-sockets \ --with-xmlrpc \ --enable-zip \ --enable-soap \ --enable-short-tags \ --enable-static \ --with-xsl \ --with-fpm-user=apache \ --with-fpm-group=apache \ --enable-ftp
[root@marvin php-5.6.19]#make && make install [root@marvin php-5.6.19]# cp php.ini-development /etc/php.ini [root@marvin php-5.6.19]# cp sapi/fpm/init.d.php-fpm /etc/rc.d/init.d/php-fpm [root@marvin php-5.6.19]# chmod +x /etc/rc.d/init.d/php-fpm [root@marvin php-5.6.19]# chkconfig --add php-fpm [root@marvin php-5.6.19]# chkconfig php-fpm on
[root@marvin etc]# cd /usr/local/phpfpm/etc [root@marvin phpfpm]# cp php-fpm.conf.default php-fpm.conf [root@marvin phpfpm]# vim php-fpm.conf pm.max_children = 50 pm.start_servers = 5 pm.min_spare_servers = 2 pm.max_spare_servers = 8 pid = /usr/local/phpfpm/var/run/php-fpm.pid
配置apache
[root@martin httpd]# vim /etc/httpd/httpd.conf
在Apache httpd 2.4以后已经专门有一个模块针对FastCGI的实现,此模块为mod_proxy_fcgi.so,它其实是作为mod_proxy.so模块的扩充,因此,这两个模块都要加载:
LoadModule proxy_module modules/mod_proxy.so LoadModule proxy_fcgi_module modules/mod_proxy_fcgi.so
开启url rewrite:
LoadModule rewrite_module modules/mod_rewrite.so
开启防止启动警告
ServerName www.example.com:80
开启虚拟主机:
Include /etc/httpd/extra/httpd-vhosts.conf
虚拟主机:
[root@martin httpd]# vim /etc/httpd/extra/httpd-vhosts.conf
<VirtualHost *:80> DocumentRoot "/www/web/forum" ServerName www.forum.com ProxyRequests Off ProxyPassMatch ^/(.*\.php)$ fcgi://127.0.0.1:9000/www/web/forum/$1 <Directory "/www/web/forum"> Options none AllowOverride none Require all granted </Directory> </VirtualHost>
over